if (typeof(nrdp) == 'undefined')
{
	nrdp = {};
	
	nrdp.command = 
	{
		ready : true,
		commands : [],
		timer : null
	};
	
	nrdp.command.exec = function(cmd, args)
	{
		nrdp.command.commands.push(cmd + "?" + args);
		
		if (nrdp.command.timer == null)
			nrdp.command.timer = setInterval(nrdp.command.run_command, 10);
	}
	
	nrdp.command.run_finished = function()
	{
		var now = new Date().getTime();
		var elapsed = now - nrdp.command.function_start_time;
		//alert(elapsed + " ms");
	}
	
	nrdp.command.run_command = function()
	{
		if (nrdp.command.ready == false)
			return;
		
		nrdp.command.ready = false;
		
		var command_sequence = nrdp.command.commands.shift();
		
		if (nrdp.command.commands.length == 0)
		{
			clearInterval(nrdp.command.timer);
			nrdp.command.timer = null;
		}
		
		nrdp.command.function_start_time = new Date().getTime();
		
		window.location = "nflxjs://" + command_sequence;
	}
	
	nrdp.command.fast_exec = function(cmd, args, handler)
	{
		try
		{
			var xhReq = new XMLHttpRequest();
			
			xhReq.open("GET", "nflxjs#" + cmd + "?" + args, true);
			
			xhReq.onreadystatechange = function()
			{
				if (xhReq.readyState === 4)
				{
					//alert(xhReq.responseText);
					if (typeof(handler) !== 'undefined' && handler !== null)
						handler(xhReq.responseText);
				}
			};
			
			xhReq.send(null);
			
//			if (typeof(handler) !== 'undefined' && handler !== null)
//			{
//				handler(xhReq.responseText);
//			}
			
		//	return xhReq.responseText;
		}
		catch (e)
		{
			alert(e);
		//	return null;
		}
	}
	
	nrdp.device = {};
	
	nrdp.device._networkConnected = true;	// assume connected initially, since we are running inside a web view that was just loaded
	
	nrdp.device.getSoftwareVersion = function()
	{
		return "DEVICE_GETSOFTWAREVERSION_VALUE";
	}
	
	nrdp.device.getCertificationVersion = function()
	{
		return "DEVICE_GETCERTIFICATIONVERSION_VALUE";
	}
	
	nrdp.device.getESN = function()
	{
		return "DEVICE_GETESN_VALUE";
	}
	
	nrdp.device.getESNPrefix = function()
	{
		return "DEVICE_GETESNPREFIX_VALUE";
	}
	
	nrdp.device.setUIVersion = function(version)
	{
		nrdp.command.exec("setUIVersion", version);
	}

	nrdp.device.launchUrl = function(url)
	{
		nrdp.command.exec("launchUrl", url);
	}

    nrdp.device.notifyOnLogin = function()
	{
		nrdp.command.exec("notifyOnLogin", "data");
	}

	nrdp.device.notifyOnLogout = function()
	{
		nrdp.command.exec("notifyOnLogout", "data");
	}
	
	nrdp.device.notifyOnReady = function()
	{
		nrdp.command.exec("notifyOnReady", "data");
	}

	nrdp.device.getMemoryInfo = function()
	{
		nrdp.command.exec("getMemoryInfo", "data");
	}
	
	nrdp.device.isConnected = function()
	{
		return nrdp.device._networkConnected;
	}
	
	nrdp.device.notifyShowAddressBar = function(show)
	{
		nrdp.command.exec("notifyShowAddressBar", show);
	}
	
	nrdp.device.addEventListener = function(type, listener, useCapture)
	{
		document.addEventListener(type, listener, useCapture);
	}
	
	nrdp.device.removeEventListener = function(type, listener, useCapture)
	{
		document.removeEventListener(type, listener, useCapture);
	}
	
	nrdp.device.dispatchEvent = function(evt)
	{
		document.dispatchEvent(evt);
	}
	
	nrdp.device._dispatchEvent = function(evt_type, evt_name, parameters)
	{
		var evt = document.createEvent(evt_type);
		evt.initEvent(evt_name, true, true);
		evt.parameters = parameters;
		
		nrdp.device.dispatchEvent(evt);
	}
	
	//	Create the nrdp object here. Some of the commands are dynamics
	nrdp.video = {};
	
	nrdp.video.addEventListener = function(type, listener, useCapture)
	{
		document.addEventListener(type, listener, useCapture);
	}
	
	nrdp.video.removeEventListener = function(type, listener, useCapture)
	{
		document.removeEventListener(type, listener, useCapture);
	}
	
	nrdp.video.dispatchEvent = function(evt)
	{
		document.dispatchEvent(evt);
	}
	
	nrdp.video._dispatchEvent = function(evt_type, evt_name)
	{
		var evt = document.createEvent(evt_type);
		evt.initEvent(evt_name, true, true);
		
		nrdp.video.dispatchEvent(evt);
	}
	
	nrdp.webapi = {};
	
	nrdp.webapi.getConsumerKey = function()
	{
		return "WEBAPI_GETCONSUMERKEY_VALUE";
	}
	
	nrdp.webapi.getConsumerSecret = function()
	{
		return "WEBAPI_GETCONSUMERSECRET_VALUE";
	}
	
	nrdp.webapi.hmacSha1 = function(key, plaintext, handler)
	{
		nrdp.command.exec("hmacSha1Queued", key + "&" + plaintext + "&" + handler);
	}
	
	nrdp.webapi.hmacSha1ShortCircuit = function(key, plaintext, handler)
	{
		return nrdp.command.fast_exec("hmacSha1", key + "&" + plaintext, handler);
	}
	
	nrdp.webapi.addEventListener = function(type, listener, useCapture)
	{
		document.addEventListener(type, listener, useCapture);
	}
	
	nrdp.webapi.removeEventListener = function(type, listener, useCapture)
	{
		document.removeEventListener(type, listener, useCapture);
	}
	
	nrdp.webapi.dispatchEvent = function(evt)
	{
		document.dispatchEvent(evt);
	}
	
	nrdp.webapi._dispatchEvent = function(evt_type, evt_name, parameters)
	{
		var evt = document.createEvent(evt_type);
		evt.initEvent(evt_name, true, true);
		evt.parameters = parameters;
		
		nrdp.webapi.dispatchEvent(evt);
	}	
	
	nrdp.service = {};

	nrdp.service.authorize = function(parameters)
	{
		nrdp.command.exec("authorizeService", JSON.stringify(parameters));
	}
	
	nrdp.service.deauthorize = function(parameters)
	{
		nrdp.command.exec("deauthorizeService", JSON.stringify(parameters));
	}
	
	nrdp.service.addEventListener = function(type, listener, useCapture)
	{
		document.addEventListener(type, listener, useCapture);
	}
	
	nrdp.service.removeEventListener = function(type, listener, useCapture)
	{
		document.removeEventListener(type, listener, useCapture);
	}
	
	nrdp.service.dispatchEvent = function(evt)
	{
		document.dispatchEvent(evt);
	}
	
	nrdp.service._dispatchEvent = function(evt_type, evt_name, parameters)
	{
		var evt = document.createEvent(evt_type);
		evt.initEvent(evt_name, true, true);
		evt.parameters = parameters;
		
		nrdp.service.dispatchEvent(evt);
	}
	
	
	nrdp.device.addEventListener('networkconnected',	function (arg)
								 {
									nrdp.device._networkConnected = true;
								 }
								 ,false);

	nrdp.device.addEventListener('networkconnectionlost',	function (arg)
								 {
								 nrdp.device._networkConnected = false;
								 }
								 ,false);
	
	
}


